leetcode 3254 长度为 K 的子数组的能量值 I 中等

给你一个长度为 n 的整数数组 nums 和一个正整数 k 。

一个数组的 能量值 定义为:

  • 如果 所有 元素都是依次 连续 且 上升 的,那么能量值为 最大 的元素。
  • 否则为 -1 。

你需要求出 nums 中所有长度为 k 的

子数组

的能量值。

请你返回一个长度为 n - k + 1 的整数数组 results ,其中 results[i] 是子数组 nums[i..(i + k - 1)] 的能量值。

示例 1:

**输入:**nums = 1,2,3,4,3,2,5, k = 3

输出:3,4,-1,-1,-1

解释:

nums 中总共有 5 个长度为 3 的子数组:

  • [1, 2, 3] 中最大元素为 3 。
  • [2, 3, 4] 中最大元素为 4 。
  • [3, 4, 3] 中元素 不是 连续的。
  • [4, 3, 2] 中元素 不是 上升的。
  • [3, 2, 5] 中元素 不是 连续的。

示例 2:

**输入:**nums = 2,2,2,2,2, k = 4

输出:-1,-1

示例 3:

**输入:**nums = 3,2,3,2,3,2, k = 2

输出:-1,3,-1,3,-1

提示:

  • 1 <= n == nums.length <= 500
  • 1 <= nums[i] <= 10e5
  • 1 <= k <= n

分析:由于数组的长度只有500,因此我们可以枚举当前下标向前k位是否连续且递增。

cpp 复制代码
/**
 * Note: The returned array must be malloced, assume caller calls free().
 */
int* resultsArray(int* nums, int numsSize, int k, int* returnSize) {
    *returnSize=numsSize-k+1;
    int *result=(int*)malloc(sizeof(int)*numsSize-k+1);

    for(int i=k-1;i<numsSize;++i)
    {
        int f=1;
        for(int j=i,t=k-1;t>0;t--,j--)
        {
            if(nums[j]!=nums[j-1]+1)
            {
                f=-1;break;
            }
        }
        if(f==-1)result[i+1-k]=-1;
        else result[i+1-k]=nums[i];
    }

    return result;
}

当然,如果数据范围很大,枚举就会超时。实际上不需要每个点都枚举。

根据题意可知,由于子数组如果满足连续上升,此时相邻元素的差值一定为 1,此时我们在遍历数组的同时,用一个计数器 cnt 统计以当前索引 i 为结尾时连续上升的元素个数,初始化 cnt=0,此时:

如果满足 i=0 或者 numsi−numsi−1=1 时,此时 cnt=cnt+1,即在 numsi−1 末尾可以追加元素 numsi 仍然满足连续上升;numsi−numsi−1!=1 时,此时 cnt 重新置为 1,即在 numsi−1 末尾无法追加 numsi;

在计算的同时,此时如果以 numsi 为结尾的连续上升的元素数组如果大于等于 k,则当前一定存在长度为 k 且以 numsi 为结尾的连续上升的子数组,此时能量值即为 numsi;如果不满足,则无法构成长度为 k 且连续上升的子数组,则当前能量值为 −1,返回最终统计的能量值即可。

cpp 复制代码
/**
 * Note: The returned array must be malloced, assume caller calls free().
 */
int* resultsArray(int* nums, int numsSize, int k, int* returnSize) {
    *returnSize=numsSize-k+1;
    int *result=(int*)malloc(sizeof(int)*numsSize-k+1);
    for(int i=0;i<*returnSize;++i)
        result[i]=-1;
    int cnt=0;
    for(int i=0;i<numsSize;++i)
    {
        if(i==0||nums[i]-nums[i-1]==1)cnt=cnt+1;
        else cnt=1;
        if(cnt>=k)result[i-k+1]=nums[i];
    }

    return result;
}
相关推荐
All for pursuit.6 小时前
【分治-3】347.前K个高频元素
数据结构·c++·算法·leetcode
All for pursuit.7 小时前
【二分查找-2】34.在排序数组中查找元素的第一个和最后一个位置
数据结构·c++·算法·leetcode
blxr_12 小时前
力扣hot100爬楼梯https://leetcode.cn/problems/climbing-stairs/
算法·leetcode·职场和发展
Navigator_Z13 小时前
LeetCode //C - 1275. Find Winner on a Tic Tac Toe Game
c语言·算法·leetcode
All for pursuit.15 小时前
【分治-2】215.数组中的第K个最大元素
数据结构·c++·算法·leetcode
blxr_16 小时前
力扣hot100前k个高频元素https://leetcode.cn/problems/top-k-frequent-elements/
算法·leetcode·职场和发展
longlongzihan1 天前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
smj2302_796826521 天前
解决leetcode第4064题至多一次取反能被k整除的最长子数组II
python·算法·leetcode
青山木1 天前
Hot 100 --- 下一个排列
java·数据结构·算法·leetcode
垆边人似月.1 天前
字符串重排后最大字典序
算法·leetcode·职场和发展